       SUBROUTINE m_breeze1_wf_3e(rlat,rlon,mlon,kmb,itap,mlev,
     $        cdragh,m_beta,slope,dzh,dzh_2,msig,mdx,
     $        mtsrf_surf,qsat_ts,f_sens,f_lat,
     $        t_e,theta_e,tv_e,q_e,coef_T,w_e,p_e,paprs,
     $        eq_kk,x1,x2,x3,m_buoy,
     $        m_wf,m_w,m_u,m_theta,m_t,m_tv,m_q,m_top,
     $        dwfdTs,dTdTs,dqdTs,ztsol)
         USE dimphy
         implicit none
       
!########################
! fichiers des parametres
!########################
#include "dimensions.h"
*KEEP,dimphy.
CC#include "dimphy.h"
!pour klon,klev
*KEEP,YOMCST.
#include "YOMCST.h" 
*KEEP,YOETHF.
#include "YOETHF.h"
*KEEP,FCTTRE.
#include "FCTTRE.h"
#include "cvthermo.h"
#include "cv3param.h"
#include "conema3.h"
#include "iniprint.h"
*KEND.
!
!!##################
!   Arguments
!##################
!
!###################################
! Dclaration des variables
!###################################
!
       integer i,k,ip,itap,mlev(klon),mlon,kmb(klon),iq
       real Pi
!---------
!  input
!---------
      real cdragh(klon),m_beta(klon),slope(klon),
     $     dzh(klon,klev),msig(klev),mdx,dzh_2(klon,klev),
     $     mtsrf_surf(klon,klev),qsat_ts(klon,klev)
      real t_e(klon,klev),theta_e(klon,klev),tv_e(klon,klev),
     $  q_e(klon,klev),coef_T(klon,klev),
     $  w_e(klon,klev),p_e(klon,klev)
      real paprs(klon,klev+1)
     
      real rlat(klon),rlon(klon)
!---------
!  output
!---------
       real eq_kk(klon,klev),x1(klon,klev),x2(klon,klev),
     $      x3(klon,klev),m_buoy(klon,klev)

       real wf2,m_wf(klon,klev+1),m_w(klon,klev), 
     $      m_theta(klon,klev),m_u(klon,klev), 
     $      m_t(klon,klev),m_tv(klon,klev),
     $      m_q(klon,klev),k_lat
       integer m_top(klon)
       real dwfdTs(klon,klev),dTdTs(klon,klev),dqdTs(klon,klev)
!
       real f_sens(klon,klev),f_lat(klon,klev)
      
!---------
!  local
!---------
      real m_rr,coef_tv,coef_buoy(klon,klev),coef_sens(klon,klev),
     $     coef_lat(klon,klev),kx,ky,gg,gq,mwfkp1
      REAL theta_f_e(klon,klev)   !theta aux interf. ; util. pour interpol sur ss-grille
      REAL q_f_e(klon,klev)       !q aux interf. ; util. pour interpol sur ss-grille
      real mtsrf(klon,klev)
      real eq_ya,eq_yb,eq_yc,eq_yd,
     $     eq_bb,eq_cc,eq_dd,eq_pp,eq_qq,eq_tt
      real e_poten,kaka
      real dqsdTs,coef_st
      real wght_qsat    !poids de qsat(Ts) dans init de humidite de brise
      real wght_prev    !poids de la valeur anterieure dans la ss-relaxation
                        !dans le calcul iteratif de l humidite de brise
      real w_offset     !offset de wf dans le calcul de l humidite de brise
      INTEGER niter,iter
      logical iflag_mb(klon)
!-------------
!  sous grille verticale
!
      INTEGER    ksublev
      PARAMETER (ksublev=20)
      INTEGER last,ksub
!  Geometrie
      REAL dzsub0    !epaisseur (m) des couches de la ss-grille vert.
      INTEGER m_s_n(klon)
      REAL m_s_dp(klon),dzh_s(klon,ksublev),dzh_s_2(klon,ksublev)
!  Environnement
      REAL t_s_e(klon,ksublev),theta_s_e(klon,ksublev),
     $ tv_s_e(klon,ksublev),q_s_e(klon,ksublev),coef_s_T(klon,ksublev),
     $ w_s_e(klon,ksublev),p_s_e(klon,ksublev)
!  Brise
      REAL m_s_wf(klon,ksublev+1),m_s_w(klon,ksublev), 
     $      m_s_theta(klon,ksublev),m_s_u(klon,ksublev), 
     $      m_s_t(klon,ksublev),m_s_tv(klon,ksublev),
     $      m_s_q(klon,ksublev),
     $      m_s_q_new(klon,ksublev)
      REAL m_s_buoy(klon,ksublev)
      REAL coef_s_buoy(klon,ksublev),coef_s_sens(klon,ksublev),
     $     coef_s_lat(klon,ksublev)
      REAL f_s_sens(klon,ksublev),f_s_lat(klon,ksublev)
      REAL dwfdTs_s(klon,ksublev),dTdTs_s(klon,ksublev),
     $     dqdTs_s(klon,ksublev)
      REAL  sum_s_w(klon,klev), sum_s_theta(klon,klev),
     $      sum_s_q(klon,klev),
     $      sum_s_sens(klon,klev),sum_s_lat(klon,klev),
     $      sum_s_buoy(klon,klev)
      logical iflag_mb_s(klon)
!--------------------
!test
        real test_m_t(klon,klev), test_m_tv(klon,klev), 
     $       test_m_q(klon,klev),
     $       test_m_buoy(klon,klev) ,test_m_w(klon,klev)  
        real buoy1(klon,klev),buoy2(klon,klev),buoy3(klon,klev)
        real ky1,ky2,ky3,ky4,eq_cbr1, eq_cbr2
        real test_eq_ya(klon,klev), test_eq_yb(klon,klev), 
     $       test_eq_yc(klon,klev), test_eq_yd(klon,klev)
        real ztsol(klon)
        logical firstcall,decoupling
        real spring
c
      data firstcall /.TRUE./, decoupling /.FALSE./
C

      IF (prt_level .GE. 20) THEN
      print *,' -> m_breeze1, mlev, mtsrf_surf ', mlev(1),
     $           (mtsrf_surf(1,k),k=1,mlev(1))
      ENDIF
           Pi=2.*asin(1.)
           eps=RD/RV
           dzsub0 = 100.      
c
c -----------------------------------------------------------------
c             Initialisation des paramtres
c -----------------------------------------------------------------
      IF (firstcall) THEN
        firstcall = .FALSE.
c
        decoupling = .FALSE.
c
c--  Lecture ventuelle des parametres dans m_breeze_param.data
c
        open(99,file='m_breeze_param.data',status='old',
     $          form='formatted',err=9999)
        read(99,*,end=9998) decoupling
9998    Continue
        close(99)
        print *,
     $  ' lecture m_breeze_param.data: decoupling',
     $              decoupling
9999    Continue
      ENDIF   ! Firstcall
!-------------------------------------------------------------------
!%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
!m_buoy calcule par kx,ky
!%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

!********************
! Initiation
!********************
      
!1)en klon
       DO k = 1,klev
           DO i=1,klon

            x1(i,k)=0.
            x2(i,k)=0.
            x3(i,k)=0.
            m_buoy(i,k)=0.
            m_theta(i,k) = 0.
            m_t(i,k) = 0.
            m_tv(i,k) = 0.
            m_q(i,k) = 0.
            m_wf(i,1)=0.
            m_wf(i,k+1)=0. 
            m_w(i,k)=0.
            m_u(i,k)=0.
            m_top(i)= 0 
            f_sens(i,k)=0.
            f_lat(i,k)=0.
            dwfdTs(i,k)=0.
            dTdTs(i,k)=0.
            dqdTs(i,k)=0.
            mtsrf(i,k) = 0.
            theta_f_e(i,k) = 0.
            q_f_e(i,k) = 0.
             ENDDO 
          ENDDO 
!1.5)en klon pour la sous-grille verticale
      m_s_dp  =0.
      dzh_s   =0.
      dzh_s_2 =0.
      m_s_wf  =0.
      m_s_w   =0.
      m_s_theta =0.
      m_s_u   =0.
      m_s_t   =0.
      m_s_tv  =0.
      m_s_q   =0.
      m_s_q_new =0.
      dwfdTs_s=0.
      dTdTs_s =0.
      dqdTs_s =0.
      t_s_e   =0.
      theta_s_e =0.
      tv_s_e  =0.
      q_s_e   =0.
      coef_s_T=0.
      w_s_e   =0.
      p_s_e   =0.
      sum_s_w = 0.
      sum_s_theta = 0.
      sum_s_q = 0.
      sum_s_sens = 0.
      sum_s_lat = 0.
!
!2) en mlon
!(mis valeur de l environnement pour la brise)
!
         DO k = 1,klev
            DO iq=1,mlon
               i= kmb(iq)
!
            m_theta(i,k) = theta_e(i,k)
            m_t(i,k) = t_e(i,k)
            m_tv(i,k) = tv_e(i,k)
            m_q(i,k) = q_e(i,k)

            ENDDO
         ENDDO
!  Derivees
      DO k = 1,klev
        DO iq = 1,mlon
            i=kmb(iq)
       dwfdTs(i,k)=0.
       dTdTs(i,k)=0.
       dqdTs(i,k)=0.
        ENDDO
       ENDDO
! temperature potentielle et humidite de l envt aux interfaces
         DO k = 2,klev
            DO iq=1,mlon
               i= kmb(iq)
          theta_f_e(i,k) = ( (paprs(i,k)-p_e(i,k))*theta_e(i,k-1) + 
     $                       (p_e(i,k-1)-paprs(i,k))*theta_e(i,k)) /
     $                     (p_e(i,k-1)-p_e(i,k))
          q_f_e(i,k) = ( (paprs(i,k)-p_e(i,k))*q_e(i,k-1) + 
     $                       (p_e(i,k-1)-paprs(i,k))*q_e(i,k)) /
     $                     (p_e(i,k-1)-p_e(i,k))
            ENDDO
         ENDDO
            DO iq=1,mlon
               i= kmb(iq)
          theta_f_e(i,1) = Theta_e(i,1)
          q_f_e(i,1) = q_e(i,1)
            ENDDO
!Eviter m_beta=0, donne coef_lat=0, et dwfdTs est NaN.
          DO iq=1,mlon
               i= kmb(iq)
              if(m_beta(i).le.0.) then
                   m_beta(i)=1.e-6
              endif
          ENDDO
!------------------------------------------------------------
      IF (decoupling) THEN
!--- test de decouplage schema de surface(m_tsurf)
       DO k=1,klev
         DO iq=1,mlon
             i= kmb(iq)
              if (k.le.mlev(i))then
                  mtsrf(i,k)=ztsol(i)  
              endif !(k.le.mlev(i))
          ENDDO
         ENDDO
      ELSE !(decoupling)
       DO k=1,klev
         DO iq=1,mlon
             i= kmb(iq)
              if (k.le.mlev(i))then
                  mtsrf(i,k)=mtsrf_surf(i,k)
              endif !(k.le.mlev(i))
          ENDDO
         ENDDO
      endif !(decoupling)
!------------------------------------------------------------
!********************************
!m_wf,m_w,m_theta,m_q,m_buoy
!********************************
      DO iq = 1,mlon
          i=kmb(iq)
       iflag_mb(i) = .TRUE.
      ENDDO

!#########################################################
      DO k = 1,klev       ! Boucle sur les niveaux de LMDZ
!#########################################################
!
!===========================================
! Preparation de la boucle sur la sous-grille verticale
!===========================================
!
!-----------------------------------
! Initialisation des variables de brise de la premiere ss-couche
!-----------------------------------
        IF (k .EQ. 1) THEN
!Dans la premiere couche, la premiere ss-couche est vide
        DO iq = 1,mlon
            i=kmb(iq)
         IF (k.le.mlev(i)) THEN
! Environnement
              p_s_e(i,1) = paprs(i,1)
              coef_s_T(i,1) = 0.
              theta_s_e(i,1) = 0.
              q_s_e(i,1) = 0.
              t_s_e(i,1) = 0.
              tv_s_e(i,1)= 0.
! Grille
           dzh_s(i,1) = 0.
           dzh_s_2(i,1) = 0.
! Brise
             m_s_theta(i,1) = 0.
             m_s_t(i,1)     = 0.
             m_s_tv(i,1)    = 0.
             m_s_q(i,1)     = 0.
             m_s_q_new(i,1) = 0.
             m_s_w(i,1)     = 0.
             m_s_wf(i,1)    = 0.
             m_s_wf(i,2)    = 0.
         ENDIF    !  (k.le.mlev(i))
        ENDDO
        ELSE      !  (k .EQ. 1)
!A partir de la 2e couche, la premiere ss-couche est la 
!derniere ss-couche de la couche precedente
        DO iq = 1,mlon
            i=kmb(iq)
         IF (k.le.mlev(i)) THEN
              last = m_s_n(i)
! Environnement
              p_s_e(i,1) =    p_s_e(i,last)       
              coef_s_T(i,1) = coef_s_T(i,last)    
              theta_s_e(i,1) =theta_s_e(i,last)   
              q_s_e(i,1) =    q_s_e(i,last)       
              t_s_e(i,1) =    t_s_e(i,last)       
              tv_s_e(i,1)=    tv_s_e(i,last)      
! Grille
           dzh_s(i,1) = dzh_s(i,last)
           dzh_s_2(i,1) =  0.5*dzh_s(i,1)+0.5*dzh_s(i,last)
! Brise
             m_s_theta(i,1) = m_s_theta(i,last)
             m_s_t(i,1)     = m_s_t(i,last)    
             m_s_tv(i,1)    = m_s_tv(i,last)   
             m_s_q(i,1)     = m_s_q(i,last)    
             m_s_w(i,1)     = m_s_w(i,last)    
             m_s_wf(i,1)    = m_s_wf(i,last)   
             m_s_wf(i,2)    = m_s_wf(i,last+1)   
         ENDIF
        ENDDO
        ENDIF     !  (k .EQ. 1)
!
!-----------------------------------
! Definition de la ss-grille
!-----------------------------------
        DO iq = 1,mlon
            i=kmb(iq)
         IF (k.le.mlev(i)) THEN
! subdivision en ss-couches epaisse d au plus dzsub0, en ajoutant une ss-couche 
! recouvrant la derniere ss-couche de la couche precedente.
           m_s_n(i) = (paprs(i,k)-paprs(i,k+1))*RD*t_e(i,k)/
     $                 (p_e(i,k)*Rg*dzsub0) + 2
           IF (k .EQ. 1) m_s_n(i) = 2
           m_s_dp(i) = (paprs(i,k)-paprs(i,k+1))/(m_s_n(i)-1)
         ENDIF
        ENDDO
      IF (prt_level .GE. 20) THEN
        print *,'k,m_s_n,m_s_dp ',k,m_s_n,m_s_dp
      ENDIF

!-----------------------------------
! Initialisation des variables de l environnement des ss-couches
!-----------------------------------
        DO ksub = 2,ksublev
        DO iq = 1,mlon
            i=kmb(iq)
         IF (k.le.mlev(i) .AND. ksub .LE. m_s_n(i)) THEN
              p_s_e(i,ksub) = paprs(i,k) - m_s_dp(i)*(ksub-1.5)
              coef_s_T(i,ksub) = (p_s_e(i,ksub)/100000.)**RKAPPA
              theta_s_e(i,ksub) = theta_f_e(i,k)+
     $            (theta_f_e(i,k+1)-theta_f_e(i,k))*
     $             (float(ksub)-1.5)/m_s_n(i)
              q_s_e(i,ksub) = q_f_e(i,k)+
     $            (q_f_e(i,k+1)-q_f_e(i,k))*
     $             (float(ksub)-1.5)/m_s_n(i)
              t_s_e(i,ksub) = theta_s_e(i,ksub)*coef_s_T(i,ksub)
              m_rr=q_s_e(i,ksub)/(1-q_s_e(i,ksub)) 
              tv_s_e(i,ksub)=t_s_e(i,ksub)*(1.+RD/RV*m_rr)
           dzh_s(i,ksub) = dzh(i,k)/(m_s_n(i)-1)
           dzh_s_2(i,ksub) =  0.5*dzh_s(i,ksub)+0.5*dzh_s(i,ksub-1)
      IF (prt_level .GE. 20) THEN
          print *,'k,ksub,dzh_s(i,ksub),t_s_e(i,ksub) ',
     $             k,ksub,dzh_s(i,ksub),t_s_e(i,ksub)
      ENDIF
        ENDIF
        ENDDO
        ENDDO
!
!-----------------------------------
! Initialisation de l humidite de la brise 
!-----------------------------------
        wght_qsat = 0.01 ! poids de qsat(Ts) dans la valeur initiale
        wght_prev = 0.3  ! poids de la valeur antrieure dans la ss-relaxation.
        DO ksub = 2,ksublev
          DO iq = 1,mlon
              i=kmb(iq)
           IF (k.le.mlev(i) .AND. ksub .LE. m_s_n(i)) THEN
             m_s_q(i,ksub) = (1.-wght_qsat)*q_s_e(i,ksub)+
     $                       wght_qsat     *qsat_ts(i,k)
             m_s_q_new(i,ksub) = m_s_q(i,ksub)
           ENDIF
          ENDDO
        ENDDO
!-----------------------------------
! Initialisation des variables de sommation
!-----------------------------------
      sum_s_theta = 0.
      sum_s_q = 0.
      sum_s_w = 0.
      sum_s_buoy = 0.
      sum_s_sens = 0.
      sum_s_lat = 0.
!
      DO iq = 1,mlon
          i=kmb(iq)
       iflag_mb_s(i) = .TRUE.
      ENDDO
!
!===========================================
! Calcul de la brise 
!===========================================
!
!---------------------------------------
!(1) niveau endessous de relief
!---------------------------------------
!  Le long du relief, on fait du level-splitting : on sub-divise les
! couches en ss-couches d epaisseur maximale dzsub0.
!-----------------------------------------
        DO ksub = 2,ksublev
cc        niter = 2
cc        niter = 4
        niter = 6
        DO iter = 1,niter
        DO iq = 1,mlon
            i=kmb(iq)
!!          print *,' bcle sur ss-couches, k,ksub ',k,ksub
         IF (k.le.mlev(i) .AND. ksub .LE. m_s_n(i)) THEN
      IF (prt_level .GE. 20) THEN
           print *,'mtsrf(i,k) .GT. t_e(i,k) ? ',
     $              mtsrf(i,k), t_e(i,k)
      ENDIF
          IF (mtsrf(i,k) .GT. t_e(i,k))THEN
!control pour ne pas calcule m_wf quand il n'y a plus de soleill
!
!jyg : Sous-relaxation sur l humidit
         m_s_q(i,ksub) = wght_prev*m_s_q(i,ksub)
     $              +(1.-wght_prev)*m_s_q_new(i,ksub)
!
         m_rr=m_s_q(i,ksub)/(1.-m_s_q(i,ksub))
         coef_tv=1.+eps*m_rr
!!!         spring=sin(slope(i))*abs(m_s_wf(i,ksub))+1.
         spring=abs(m_s_wf(i,ksub))/sin(slope(i))+1.
!
         coef_s_buoy(i,ksub)=RG/tv_s_e(i,ksub)*dzh_s(i,ksub)
         coef_s_sens(i,ksub)=
     $               cdragh(i)*spring*
     $               msig(k)/coef_s_T(i,ksub)*dzh_s(i,ksub)
         coef_s_lat(i,ksub)=m_beta(i)*cdragh(i)*
     $        spring*msig(k)*dzh_s(i,ksub)

         kx=1./(coef_s_buoy(i,ksub)*coef_tv)
         ky=  -m_s_wf(i,ksub)**2/(coef_s_buoy(i,ksub)*coef_tv)+
     $           tv_s_e(i,ksub)/coef_tv
           

         eq_ya=kx/coef_s_T(i,ksub)
         eq_yb=coef_s_sens(i,ksub)*kx
         eq_yc=ky/coef_s_T(i,ksub)-theta_s_e(i,ksub)
         eq_yd=-m_s_wf(i,ksub)*(m_s_theta(i,ksub-1)-theta_s_e(i,ksub))-
     $          coef_s_sens(i,ksub)*(mtsrf(i,k)-ky)
cc         print *,'equ. 1, k,eq_ya,eq_yb,eq_yc,eq_yd ',
cc     $                    k,eq_ya,eq_yb,eq_yc,eq_yd
!!         IF (eq_yd .GT. 0.) THEN
!!           print *,'eq_yd positif !!!!!'
      IF (prt_level .GE. 20) THEN
           print *,
     $'k,ksub,m_s_wf(i,ksub),m_s_theta(i,ksub-1),theta_s_e(i,ksub) ',
     $ k,ksub,m_s_wf(i,ksub),m_s_theta(i,ksub-1),theta_s_e(i,ksub)
           print *,'k,ksub,coef_s_sens(i,ksub),mtsrf(i,k),ky ',
     $              k,ksub,coef_s_sens(i,ksub),mtsrf(i,k),ky
      ENDIF
!!         ENDIF
!--- choisir la solution de m_wf  
           eq_bb = eq_yb/(3.* eq_ya)
           eq_cc = eq_yc/ eq_ya
           eq_dd = eq_yd/ eq_ya
           eq_pp = -3* eq_bb**2+ eq_cc
           eq_qq = 2.* eq_bb**3- eq_cc* eq_bb+ eq_dd
           eq_kk(i,ksub) = 4.* eq_pp**3/27+ eq_qq**2
!-------------------------------------------------
       if(eq_kk(i,ksub).lt.0.) then
!-- 3 solutions:
           eq_tt = 1./3.*acos(3.*eq_qq/(2.*eq_pp)*sqrt(-3./eq_pp))
!
           x1(i,ksub) = -eq_bb+sqrt(-4.*eq_pp/3.)*cos(eq_tt)
           x2(i,ksub) = -eq_bb+sqrt(-4.*eq_pp/3.)*cos(eq_tt+2*Pi/3.)
           x3(i,ksub) = -eq_bb+sqrt(-4.*eq_pp/3.)*cos(eq_tt+4*Pi/3.)
!           print*,'eq_kk<0,k,x1,x2,x3',
!     $          k,x1(i,ksub),x2(i,ksub),x3(i,ksub)
!
            m_s_wf(i,ksub+1)=max(x1(i,ksub),x2(i,ksub),x3(i,ksub))
!
       else if(eq_kk(i,ksub).eq.0.) then
!-- 2 solutions:
            x1(i,ksub) = -eq_bb-sign(abs(4.*eq_qq)**(1./3.),4.*eq_qq)
            x2(i,ksub) = -eq_bb+sign(abs(eq_qq/2.)**(1./3.),eq_qq/2.)
!
!           print*,'eq_kk=0,k,ksub,x1,x2',k,ksub,x1(i,ksub),x2(i,ksub)
            m_s_wf(i,ksub+1) = max(x1(i,ksub),x2(i,ksub))
!
       else! eq_kk>0
!-- 1 solution:
            gg = (-eq_qq-sign(sqrt(eq_kk(i,ksub)),eq_qq))*0.5
            gq = (-2.*eq_pp**3/27.)/
     $            (-eq_qq-sign(sqrt(eq_kk(i,ksub)),eq_qq))
!
           
            m_s_wf(i,ksub+1) = -eq_bb+sign((abs(gg))**(1./3.),gg)
     $                +sign((abs(gq))**(1./3.),gq)
!             print*,
!     $    'eq_kk>0,k,ksub,m_s_wf(ksub+1)',k,ksub,m_s_wf(i,ksub+1)
       endif  !(eq_kk.lt.0.)
      IF (prt_level .GE. 20) THEN
      print *,'resol ',iter,' ; k,ksub,m_s_wf(i,ksub+1) ',
     $                     k,ksub,m_s_wf(i,ksub+1)
      ENDIF
!-----------------------------------------------------------
!jyg : Si m_wf(k+1) est negative, la brise detraine completement dans cette 
!jyg couche. Alors, m_wf(k+1) est mise a zero et la brise pourra repartir a
!jyg zero dans la couche au-dessus.
!
       m_s_wf(i,ksub+1) = max(m_s_wf(i,ksub+1),0.)
!
!--- m_t,m_theta
            m_s_t(i,ksub)=kx*m_s_wf(i,ksub+1)**2+ky
            m_s_theta(i,ksub)= m_s_t(i,ksub)/coef_s_T(i,ksub)

!--- m_q 
cjyg  Formule generale valable dans les cas entrainant et detrainant
!       m_s_wf(i,k+1) --> max(m_s_wf(i,k+1), m_s_wf(i,k))
cjyg(20091002)  Pour eviter les discontinuites en wf=0, ajout d un offset aux
c               poids de q_e(k) et q(k-1)
         w_offset = 1.e-3
         if (k.eq.1) then
!!            gg=coef_s_lat(i,ksub)*qsat_ts(i,k)+
!!     $          max(m_s_wf(i,ksub+1), m_s_wf(i,ksub))*q_s_e(i,ksub) 
!!!     $          m_s_wf(i,ksub+1)*q_s_e(i,ksub) 
            gg=coef_s_lat(i,ksub)                      *qsat_ts(i,k)+
     $          (max(m_s_wf(i,ksub+1), m_s_wf(i,ksub))+
     $              w_offset                          )*q_s_e(i,ksub) 
         else
!!            gg=coef_s_lat(i,ksub)*qsat_ts(i,k)+
!!     $       max(m_s_wf(i,ksub+1), m_s_wf(i,ksub))*q_s_e(i,ksub)+
!!!     $       m_s_wf(i,ksub+1)*q_s_e(i,ksub)+
!!     $       m_s_wf(i,ksub)*(m_s_q(i,ksub-1)-q_s_e(i,ksub))
            gg=coef_s_lat(i,ksub)                      *qsat_ts(i,k)+
     $         (max(m_s_wf(i,ksub+1), m_s_wf(i,ksub))-
     $          m_s_wf(i,ksub)+
     $          w_offset                              )*q_s_e(i,ksub)+
     $         (m_s_wf(i,ksub)+w_offset)               *m_s_q(i,ksub-1)
         endif
            gq=max(m_s_wf(i,ksub+1), m_s_wf(i,ksub))+coef_s_lat(i,ksub)
     $         +2.*w_offset
!!!            gq=m_s_wf(i,ksub+1)+coef_s_lat*dzh_s(i,ksub)
        
            m_s_q_new(i,ksub)=gg/gq
!
      IF (prt_level .GE. 20) THEN
      print 1792, itap,k,ksub,iter,mtsrf(i,k),m_s_theta(i,ksub),
     $            m_s_q_new(i,ksub),m_s_t(i,ksub),m_s_wf(i,ksub+1)
1792  format ('XXX-breeze-bcle1 ',3i4,' iter ',i4,' Ts ',f8.3,
     $   ' Brise: Theta,q,T ',f8.2,f10.6,f8.3,' wf ',f8.3)
      ENDIF
!--------------------------------------
        ENDIF !(mtsrf(i,k).gt.t_e(i,k))
!---------------------------------------
       ENDIF  ! (k.le.mlev(i))
!---------------------------------------
      ENDDO   !  iq = 1,mlon
!
      ENDDO   !   iter = 1,niter
!---------------------------------------
      ENDDO   !   ksub = 2,ksublev
!
!-----------------------------------------------------
        DO ksub = 2,ksublev
        DO iq = 1,mlon
            i=kmb(iq)
         IF (k.le.mlev(i) .AND. ksub .LE. m_s_n(i)) THEN
           IF (mtsrf(i,k) .GT. t_e(i,k))THEN
!--------------------------------------------
!--- m_tv(2) 
             m_rr=m_s_q(i,ksub)/(1-m_s_q(i,ksub))
             coef_tv=1.+eps*m_rr
             m_s_tv(i,ksub)=m_s_t(i,ksub)*coef_tv

!--- m_buoy,m_w(2)
            m_s_buoy(i,ksub)=m_s_tv(i,ksub)-tv_s_e(i,ksub)
            m_s_w(i,ksub) = 0.5*(m_s_wf(i,ksub) + m_s_wf(i,ksub+1))   
      IF (prt_level .GE. 20) THEN
        print *,'itap,k<=mlev(1),ksub,m_s_w(1,ksub),m_s_w(1,ksub-1) ',
     $           itap,k,mlev(1),ksub,m_s_w(1,ksub),m_s_w(1,ksub-1)
      ENDIF
!
!--------------------------------------
!   Sommation pour calcul des moyennes
       sum_s_theta(i,k) = sum_s_theta(i,k) + m_s_theta(i,ksub)
       sum_s_q(i,k) = sum_s_q(i,k) + m_s_q(i,ksub)
!!       sum_s_w(i,k) = sum_s_w(i,k) + m_s_w(i,ksub)
       sum_s_buoy(i,k) = sum_s_buoy(i,k)+m_s_buoy(i,ksub)
!--------------------------------------
        ENDIF !(mtsrf(i,k).gt.t_e(i,k))
!---------------------------------------
       ENDIF  ! (k.le.mlev(i))
!---------------------------------------
      ENDDO   !  iq = 1,mlon
!
      ENDDO   !   ksub = 2,ksublev
!
!
!--------------------------------------
!   Calcul des variables de brise sur la grille du modele
        DO iq = 1,mlon
            i=kmb(iq)
         IF (k.le.mlev(i)) THEN
          IF (mtsrf(i,k) .GT. t_e(i,k) .AND. iflag_mb(i))THEN
!
           mwfkp1=m_s_wf(i,m_s_n(i)+1)
!!           IF (mwfkp1 .LT. m_wf(i,k)) THEN
!!            m_theta(i,k) = theta_e(i,k)
!!            m_q(i,k) = q_e(i,k)
!!            m_wf(i,k+1) = 0.
!!            m_w(i,k) = 0.
!!            m_buoy(i,k) = 0.
!!           ELSE
            m_theta(i,k) = sum_s_theta(i,k)/(m_s_n(i)-1)
            m_q(i,k) = sum_s_q(i,k)/(m_s_n(i)-1)
            m_wf(i,k+1) = mwfkp1
            m_w(i,k) = 0.5*(m_wf(i,k) + m_wf(i,k+1))   
!!            m_w(i,k) = sum_s_w(i,k)/(m_s_n(i)-1)
            m_buoy(i,k) = sum_s_buoy(i,k)/(m_s_n(i)-1)
!!           ENDIF   ! (m_wf(i,k+1) .LT. m_wf(i,k))
!
           m_t(i,k) = m_theta(i,k)*coef_T(i,k)
           m_rr=m_q(i,k)/(1-m_q(i,k))
           coef_tv=1.+eps*m_rr
           m_tv(i,k)=m_t(i,k)*coef_tv
           

!------------------------------------------------------
!--- f_sens,f_lat
!pour m_breeze2
!!!             spring=sin(slope(i))*abs(m_wf(i,k))+1.
         spring=abs(m_s_wf(i,ksub))/sin(slope(i))+1.
         coef_buoy(i,k)=RG/tv_e(i,k)*dzh(i,k)
         coef_sens(i,k)=cdragh(i)*spring*
     $                 msig(k)/coef_T(i,k)*dzh(i,k)
         coef_lat(i,k)=m_beta(i)*cdragh(i)*
     $        spring*msig(k)*dzh(i,k)
             f_sens(i,k)=cdragh(i)*spring*
     $            (mtsrf(i,k)-m_t(i,k))*msig(k)
             f_lat(i,k)=m_beta(i)*cdragh(i)*
     $            spring*
     $            (qsat_ts(i,k)-m_q(i,k))*msig(k) 
!
      IF (prt_level .GE. 20) THEN
      print 1793, itap,k,m_theta(i,k),m_q(i,k),m_t(i,k),
     $            m_wf(i,k+1),m_w(i,k)
1793  format ('XXX-breeze-bcle2 ',2i4,f8.2,f10.6,f8.2,f8.3,f8.3)
      ENDIF
!--------------------------------------
        endif !(mtsrf(i,k).gt.t_e(i,k))
!---------------------------------------
!(2) niveau audessus de relief
!audessu de relief,MB monte adiabatique,16/dec/2008
!---------------------------------------
! pas de level-splitting dans cette partie
!!!!          ELSEIF (iflag_mb(i)) THEN ! IF (k.le.mlev(i))
          ELSEIF (m_wf(i,k) .GT. 0.) THEN ! IF (k.le.mlev(i))
!control de m_buoy par m_w(k-1)
!-----------------------------------------------
               m_theta(i,k)=m_theta(i,mlev(i))
               m_q(i,k)=m_q(i,mlev(i))
               m_rr=m_q(i,k)/(1-m_q(i,k))
               m_t(i,k) = m_theta(i,k)*coef_T(i,k)
               m_tv(i,k)=m_t(i,k)*(1.+RD/RV*m_rr)
               m_buoy(i,k)=m_tv(i,k)-tv_e(i,k) 
               e_poten= 
     $           RG*(m_buoy(i,k)+m_buoy(i,k-1))/(tv_e(i,k)+tv_e(i,k-1))
     $           *dzh_2(i,k)
!e_poten= RG*(0.5*(m_buoy(i,k)+m_buoy(i,k-1)))/(0.5*(tv_e(i,k)+tv_e(i,k-1)))
!         *dzh_2(i,k)
               kaka=e_poten+0.5*m_w(i,k-1)**2
!energy potentille 
!k>mlev,k-1 ne sera pas nan
                 if (kaka.gt.0.) then
                  m_w(i,k)=sqrt(2.*kaka)
                  m_wf(i,k+1)=2.*m_w(i,k)-m_wf(i,k)
!ajout pour m_u
                 endif
!            print *,'itap,k>mlev(1),m_w(1,k),m_w(1,k-1) ',
!     $               itap,k,mlev(1),m_w(1,k),m_w(1,k-1)

!---------------------------------------
           ENDIF !(k.le.mlev(i))
!--- m_u
              m_u(i,k) =  (m_wf(i,k+1) - m_wf(i,k))/dzh(i,k)*mdx  
!            print*,'m_wf',m_wf(i,k),'dzh',dzh(i,k),'mdx',mdx
          ENDDO 
!
cjylmd/jyg  Plus de test sur m_wf et m_w dans la partie le long du relief
!!!          DO iq=1,mlon
!!!               i=kmb(iq)
!!!            iflag_mb(i) = iflag_mb(i)         .AND. 
!!!     $                    m_wf(i,k+1) .GT. 0. .AND.
!!!     $                    m_w(i,k) .GT. 0.
!!!     $           .AND.     m_u(i,k) .GT. 0.
!!!          ENDDO 
!
         ENDDO          

!-- test
!      do k=1,klev
!       if (k.le.m_icbs(1))then
!        if ((m_w(i,k).ge.0.).and.(m_w(i,k).gt.0.)) then
!          print*,'0.5 m_w=0,m_w>0,k,m_icbs',m_w(1,k),k,m_icbs(1)
!        endif
!       endif
!      enddo
!--------------------------------------------
            
!*****************************************************************************
!************************
! m_top
!************************
!m_top :max niveau de mb
      do k=1,klev-1
       do iq=1,mlon
           i=kmb(iq)
         if ((m_w(i,k).gt.0.).and.(m_w(i,k+1).eq.0.))then
             m_top(i)=k
        endif
       enddo
      enddo
      IF (prt_level .GE. 20)
     $       print *,'XXX m_top ',m_top(i)
  
!***************************************************
! Derives des variables de brise par rapport mtsrf
!****************************************************
      DO k = 1,klev
        DO iq = 1,mlon
            i=kmb(iq)
       dwfdTs(i,k)=0.
       dTdTs(i,k)=0.
       dqdTs(i,k)=0.
        ENDDO
       ENDDO
!
      DO k = 1,klev
        DO iq = 1,mlon
            i=kmb(iq)
         IF (k.le.min(m_top(i),mlev(i)) 
     $       .AND. mtsrf(i,k) .GT. t_e(i,k)) THEN
!-- dwfdTs
       coef_st = coef_sens(i,k)*coef_T(i,k)
!                                                                       !jyg
!      print *,                                                          !jyg
!     $  'fin mbreeze. mtsrf(i,k),m_wf(i,k+1),coef_st,coef_lat(i,k) ',   !jyg
!     $            i,k,mtsrf(i,k),m_wf(i,k+1),coef_st,coef_lat(i,k)      !jyg
!                                                                       !jyg
       dqsdTs = qsat_ts(i,k)*RLVTT/(RV*mtsrf(i,k)**2)
cjyg : protection lorsque la brise est arretee
       IF (m_wf(i,k+1) .GT. 0.) THEN
        gg=(1.+eps*m_q(i,k))*coef_st/(m_wf(i,k+1)+coef_st)+
     $    m_t(i,k)*eps*coef_lat(i,k)*dqsdTs/(m_wf(i,k+1)+coef_lat(i,k))
        gq=2.*m_wf(i,k+1)/coef_buoy(i,k)+(1.+eps*m_q(i,k))*
     $    (m_t(i,k)-t_e(i,k))/(m_wf(i,k+1)+coef_st)+
     $    m_t(i,k)*eps*(m_q(i,k)-q_e(i,k))/(m_wf(i,k+1)+coef_lat(i,k))
        dwfdTs(i,k)=gg/gq
       ELSE
        dwfdTs(i,k)=0.
       ENDIF
!-- dTdTs
       dTdTs(i,k)=(-dwfdTs(i,k)*(m_t(i,k)-t_e(i,k))+coef_st)/
     $           (m_wf(i,k+1)+coef_st)
      IF (prt_level .GE. 20) THEN
      print *,'m_breeze1_a: k,dwfdts(k),m_t(k),t_e(k),q_e(k)',
     $        'coef_st,m_wf(k+1) ',
     $ k,dwfdts(i,k),m_t(i,k),t_e(i,k),q_e(i,k),coef_st,m_wf(i,k+1)
      print *,'m_breeze1_b: k,eps,m_q(k),coef_lat(k)',
     $        'dqsdts,coef_buoy(k) ',
     $ k,eps,m_q(i,k),coef_lat(i,k),dqsdts,coef_buoy(i,k)
      ENDIF
!-- dqdTs
       dqdTs(i,k)=(-dwfdTs(i,k)*(m_q(i,k)-q_e(i,k))+
     $                 coef_lat(i,k)*dqsdTs)/
     $     (m_wf(i,k+1)+coef_lat(i,k))
!
       
         ENDIF! (k.le.m_top(i))
        ENDDO
       ENDDO
!
       return 
       end
