!*************
! m_swdn     *
!*************
!
      SUBROUTINE m_swdn(mlon,kmb,slope,rlat,rlon,mlat_sun,
     $ local_time, mu0, swdn,m_albsol,mflux_swdn)
      USE dimphy
      implicit none

!########################
! fichiers des parametres
!########################
#include "dimensions.h"
*KEEP,dimphy.
cc#include "dimphy.h"
!pour klon,klev
!
!!##################
!   Arguments
!##################
!
! rlat(klon), rlon(klon)   --- latitude, longitude
! mlat_sun(klon) --- latitude du point subsolaire (rad)
!                \'egale "latsun" dans LMDZ4, subroutine  zenang
! gmtime --- nombre de jour
!
! slope(klon)---  pente de relief
! m_albsol(klon) --- albedo de sol 
!
! mu0(klon) --- cosine of the solar zenith angle (=0 at zenith)
! mu_sl(klon)   --- cosine of the angle between slope and sun
! teta_0,teta_sl --- sun zenith angle, slope normal zenith angle(south=0)
! psi_0, psi_sl ---  sun azimuth, slope azimuth (south=0)
!    * teta_sl:pente de relief
!    * psi_sl:orientation de pente de reilef
!
! swdn(klon,klev) --- flux swdn dans la maille
! mflux_swdn(klon,klev) --- flux swdn sur la pente de relief
!
!###################################
! D\'eclaration des variables
!###################################
!
       integer i,k,mlon,kmb(klon),iq
       real Pi,pir
    
!---------
!  input
!---------
!
       real rlat(klon), rlon(klon), mlat_sun(klon),
     $      mu0(klon),psi_sl,
     $      swdn(klon,klev),slope(klon),m_albsol(klon)  
       real local_time(klon)
      

!---------     
! output
!---------
      real mflux_swdn(klon,klev)
!--------
! local
!--------
     
      real R_omega   
      real teta_0,teta_sl,psi_0,px,py,mu_sl(klon)
!
!
!##########################################################
!Correction pour flux swdn sur le pente de relief
!(Fran\c{c}ois Forget,modifie par Jingmei YU pour m_breeze)
!
!formuls dans miniker:gama(azimuth),theta(z\'enith)
!formuls \'equivalent dans m_breeze:psi(azimuth),teta(z\'enith)
!###########################################################
! 

       Pi=2.*asin(1.)
       pir = Pi/180.

       do i=1,klon
         
!pente de relief
        slope(i) = Pi/6
!       slope(i) = Pi/3.
!11/05/2009 pour test de sensiblite de slope
!
!
       enddo
      
      do iq=1,mlon
          i= kmb(iq)
        teta_sl = slope(i)
!orientation de relief
!        psi_sl = psi_sl*pir
!attention psi_sl dans startphy.data est en degr\'ee!!
!
!       psi_sl = 315.*pir ! "orient vers sud-est"
!       psi_sl = 270.*pir ! "orient vers est"
!       psi_sl = 225.*pir ! "orient vers nord-est"
!       psi_sl = 180.*pir ! "orient vers nord"
!       psi_sl = 135.*pir ! "orient vers nord-ouest"
!       psi_sl = 90.*pir ! "orient vers ouest"
!       psi_sl = 45.*pir ! "orient vers sud-ouest"
!       psi_sl = 0.! "orient vers le sud" "config de base"
! 
!        local_time = mod((gmtime + rlon(i)/360.0*24.),24.)
!
!formule 1d:     local_time(i) = mod(gmtime,1.)
!formule 3d:
!           local_time(i)= 
!     $       mod((24.+gmtime*24 + rlon(i)/360.0*24.),24.)/24
!     $  mod((1.+gmtime + rlon(i)/360.0),1.)

!0<local_time<1, =0.5 at 12:00 LT
!0<gmtime<1
!-----------------------------------------------------------
!--- test pour gmtime, local_time
!         print*,'gmtime',gmtime,'local_time',local_time(i)
!---------------------------------------------------------------

!      IF (mu0(i).gt.0.01) THEN     ! Big loop over the entire sub qt night

c Compute azimuth of the sun : psi0 (south=0, West =pi/2)
c --------------------------

         teta_0=acos(mu0(i))
!      ENDIF
!
      IF (teta_0.lt.1.e-3) THEN
!
          psi_0=0
!
      ELSE
!
!---------------------------------------------------
!formule dans miniker:
!fun_set
!   R_omega = Pi*(2.*time/86400.-1.) ;
!
!fun_set
!   theta_sun = acos(
!    sin(lat)*sin(lat_sun) + cos(lat)*cos(lat_sun)*cos(R_omega)) ;
!
!  px = max(min(  (sin(lat)*cos(lat_sun)*cos(R_omega)-
!           cos(lat)*sin(lat_sun))  /sin(theta_sun),1.),-1.);
!fun_set
!     py = cos(lat_sun)*sin(R_omega)/sin(theta_sun);
!-------------------------------------------------------------
           R_omega = Pi*(2.*local_time(i)-1.) 
!
           px  =(sin(rlat(i)*pir)*cos(mlat_sun(i))*
     $    cos(R_omega) - cos(rlat(i)*pir)*sin(mlat_sun(i)))/sin(teta_0)
!
           py  =(cos(mlat_sun(i))*sin(R_omega))/sin(teta_0)

           px = min(px, 1.)
           px = max(px,-1.)
!
           psi_0=acos(px)
       ENDIF
!
       IF (py.lt.0) THEN
             psi_0=-psi_0
       ENDIF
!
c Compute cosine of Angle between solar beams and the normal to the slope 
c-------------------------------------------------------------
!
      mu_sl(i)=cos(teta_sl)*cos(teta_0)
!     &        + sin(teta_sl)*sin(teta_0)*cos(psi_sl - psi_0)
     &        + sin(teta_sl)*sin(teta_0)
!cos(psi_sl*pir - psi_0)=1.:l'orientation de relief suit l'orientation
! de soleille
      mu_sl(i)=max(mu_sl(i),0.)
     
      enddo  ! i=1,mlon
c
c Compute incident solar flux on the slope
c----------------------------------------------------------
      do k=1,klev
       do iq=1,mlon
           i=kmb(iq)
       mflux_swdn(i,k) = swdn(i,k) *(1.-m_albsol(i)) * mu_sl(i)

!----------------------------------
!--- test pour rlat,rlon,mflux_swdn
!
!        print*,'341,lat,lon',rlat(341),rlon(341)
   
!         mflux_swdn(i,k) = swdn(i,k) *(1.-m_albsol(i)) 
         enddo
      enddo
!------------------------------------------------------------------------
!--- test pour psi_sl,psi_0,teta_sl,teta_0,rlat,mlat_sun,swdn,mflux_swdn
!      print*,'psi_sl/pir',psi_sl/pir,'psi_0/pir',psi_0/pir
!      print*,'teta_sl/pir',teta_sl/pir,'teta_0/pir',teta_0/pir
!      print*,'rlat',rlat,'mlat_sun/pir',mlat_sun/pir
    
!      print*,'swdn',swdn,'mu_sl/pir',mu_sl/pir,'mflux_swdn',mflux_swdn
     
!-----------------------------------------------------------------------      
      return
      end


!
!****************
!   m_env       *
!****************
!
       SUBROUTINE m_env(mlon,kmb,u_e,v_e,p_e,paprs,t_e,q_e,slope,
     $      dzh,dzh_2,msig,mdx,coef_T,theta_e,rho_e,tv_e,gz_e,h_e,w_e)
         USE dimphy
         implicit none
!########################
! fichiers des parametres
!########################
#include "dimensions.h"
*KEEP,dimphy.
cc#include "dimphy.h"
!pour klon,klev
*KEEP,YOMCST.
#include "YOMCST.h" 
*KEEP,YOETHF.
#include "YOETHF.h"
*KEEP,FCTTRE.
#include "FCTTRE.h"
!
!!##################
!   Arguments
!##################
!
!###################################
! D\'eclaration des variables
!##############################<#####
!
       integer i,k,mlon,kmb(klon),iq
!---------
!  input
!---------
       real u_e(klon,klev),v_e(klon,klev),
     $   p_e(klon,klev),paprs(klon,klev+1),t_e(klon,klev),q_e(klon,klev) 
       real slope(klon),mdx
!---------     
! output
!---------
       real coef_T(klon,klev),theta_e(klon,klev),rho_e(klon,klev),
     $   tv_e(klon,klev),m_tv(klon,klev),m_tv2(klon,klev), 
     $   gz_e(klon,klev),h_e(klon,klev),w_e(klon,klev)
       real dzh(klon,klev)
       real msig(klon)
!---------
! local
!---------
       real dzh_2(klon,klev), m_rr_e(klon,klev)
!------------------------------------------------
        mdx=100.!largeur du 1ere mode
        do k=1,klev
          if (k.eq.1) then
!!jyg : essais           msig(1)=2./mdx
           msig(k)=1./mdx
!sigma=dz/(dx*dz)=1/dx
!le 1ere couche ,la surface de sol est deux fois plus que les couches audessus
          else
           msig(k)=1./mdx
          endif
        enddo
!-----------------------------------------------------------
! masse volumique de l'air de l'environnement
!------------------------------------------------------------

       DO k = 1,klev
!            DO iq = 1,mlon
!                i=kmb(iq)
          DO i=1,klon
!              coef_T(i,k) = (p_e(i,k)/p_e(i,1))**RKAPPA
              coef_T(i,k) = (p_e(i,k)/100000.)**RKAPPA
!
              theta_e(i,k) = t_e(i,k)/coef_T(i,k)
!
              rho_e(i,k) = p_e(i,k)/(RD*t_e(i,k))
!
              m_rr_e(i,k)=q_e(i,k)/(1-q_e(i,k)) 
!         
              tv_e(i,k)=t_e(i,k)*(1.+RD/RV*m_rr_e(i,k))

            ENDDO 
       ENDDO 
    
!--------------------------------------------
!\'epasseurs des couches verticales
!--------------------------------------------- 

           DO k = 1,klev
              DO i=1,klon
!dzh,distance entre deux bord de couche
               dzh(i,k) = (paprs(i,k)-paprs(i,k+1))/(rho_e(i,k)*RG)
!               msig(i) = dzh(i,1)
            ENDDO
           ENDDO 

           DO i=1,klon
!dzh_2,distance entre deux mileu de couche
               dzh_2(i,1) = 0.5*dzh(i,1)
               gz_e(i,1) = RG*dzh_2(i,1)
               h_e(i,1) = gz_e(i,1)+RCPD*t_e(i,1)
           ENDDO
           

           DO k = 2,klev
             DO i=1,klon
             dzh_2(i,k) =  0.5*dzh(i,k)+0.5*dzh(i,k-1)
             gz_e(i,k) = gz_e(i,k-1)+RG*dzh_2(i,k)
             h_e(i,k) = gz_e(i,k)+RCPD*t_e(i,k)
             ENDDO
           ENDDO 
!-----------------------------
!--- test pour gz_e
!             print*,'gz_e(100,1)',gz_e(100,1)
!--- test pour theta_e,rho_e,tv_e
!           print*,'theta_e(100,1),rho_e,tv_e',
!     $              theta_e(100,1),rho_e(100,1),tv_e(100,1) 
 
!----------------------------------------------------------------------------
! vitesse verticale de grande d'\'echelle,impos\'e,
! on peut le calculer \`a partir du sch\'ema de Lott?
!-----------------------------------------------------------------------------
           DO k = 1,klev
!            DO iq=1,mlon
!                i= kmb(iq)
             DO i=1,klon
!
               w_e(i,k) = cos(slope(i))*sin(slope(i))*
     $                    sqrt(u_e(i,k)**2+v_e(i,k)**2)
!                w_e(i,k) = 0.1
            ENDDO
           ENDDO

         return
         end

!***************
! m_ini        *
!***************
!
        SUBROUTINE m_ini(mlon,kmb,p_e,paprs,theta_e,t_e,tv_e,q_e,
     $    p_e_coupl,paprs_coupl,
     $    mflux_sens,mflux_lat,mflux_lw,
     $    rh,chi,m_icbs,m_icb,
     $    t_e_lcl,tv_e_lcl,m_plcl,m_theta_lcl,m_t_lcl,m_tv_lcl,
     $    m_q_lcl,m_w_lcl,gz_e_lcl,m_h_lcl,m_buoy_lcl,m_lv,
     $    m_w_lfc,m_plfc,
     $    kale,kcin,klfc,ok_kale,ok_kcin,ok_klfc,ok_plfc,
     $    ale_oro_therm,cin_oro_therm,m_trigger)
 
         USE dimphy
         implicit none
!########################
! fichiers des parametres
!########################
#include "dimensions.h"
*KEEP,dimphy.
CC#include "dimphy.h"
!pour klon,klev
*KEEP,YOMCST.
#include "YOMCST.h" 
*KEEP,YOETHF.
#include "YOETHF.h"
*KEEP,FCTTRE.
#include "FCTTRE.h"
#include "cvthermo.h"
#include "cv3param.h"
#include "conema3.h"
*KEND.
!
!###################################
! D\'eclaration des variables
!###################################
!
       integer i,k,mlon,kmb(klon),iq
!---------
!  input
!---------
      real p_e(klon,klev),paprs(klon,klev+1),theta_e(klon,klev),
     $     t_e(klon,klev),tv_e(klon,klev),q_e(klon,klev)
!---------
!  output
!---------
      real p_e_coupl(klon,klev),paprs_coupl(klon,klev+1)

      real mfluxg1(klon,klev),mflux_sens(klon,klev),
     $   mflux_lat(klon,klev),mflux_lw(klon,klev)

      integer m_icbs(klon),m_icb(klon)
      real rh(klon),chi(klon)

      real t_e_lcl(klon),tv_e_lcl(klon),m_plcl(klon),
     $    m_theta_lcl(klon),m_t_lcl(klon),m_tv_lcl(klon),
     $    m_q_lcl(klon),m_w_lcl(klon),gz_e_lcl(klon),m_h_lcl(klon),
     $    m_buoy_lcl(klon),m_lv(klon,klev)
      real m_w_lfc(klon),m_plfc(klon)
      integer kale(klon),kcin(klon),klfc(klon)
      logical ok_kale(klon),ok_kcin(klon),ok_klfc(klon),ok_plfc(klon)

      real ale_oro_therm(klon),cin_oro_therm(klon)

      logical m_trigger(klon)
 

!######################
! initiation
!######################
!
!1) initialisation en klon (mis zero partout)

         DO k = 1,klev
             DO i=1,klon

            p_e_coupl(i,k) = p_e(i,k)/100.
       
!different unit\'e quand coupler avec schema de deep convection

            mflux_lat(i,k) = 0.
            mflux_sens(i,k) = 0.
            mflux_lw(i,k) = 0.
!
!
            rh(i)=0.
            chi(i)=0.
            m_icbs(i) = 0
            m_icb(i) = 0

!
            t_e_lcl(i)=0.
            tv_e_lcl(i)=0.
            m_plcl(i) = 0.
            m_theta_lcl(i) = 0.
            m_t_lcl(i) = 0.
            m_tv_lcl(i) = 0.
            m_q_lcl(i) = 0.
            m_w_lcl(i) = 0.
            gz_e_lcl(i) = 0.
            m_h_lcl(i) = 0.
            m_buoy_lcl(i)=0.
            m_lv(i,k) = lv0-clmcpv*(t_e(i,k)-273.15)
          

            m_w_lfc(i)=0.
            m_plfc(i) = 0.

            kale(i)=0
            kcin(i)=0
            klfc(i)=0
            ok_kale(i)=.false.
            ok_kcin(i)=.false.
            ok_klfc(i)=.false.
            ok_plfc(i)=.false.

            ale_oro_therm(i) = 0.
            cin_oro_therm(i)=0.
            m_trigger(i) = .false.

             ENDDO 
          ENDDO 

          DO k = 1,klev
             DO i=1,klon
              paprs_coupl(i,k) = paprs(i,k)/100.
             ENDDO
          ENDDO
!
!-----------------------------------------
       return 
       end


!***************
!   m_qsat_ts  *
!***************

        SUBROUTINE m_qsat_ts(mlon,kmb,mlev,p_e,mtsrf,qsat_ts)
         USE dimphy
         implicit none
!########################
! fichiers des parametres
!########################
#include "dimensions.h"
*KEEP,dimphy.
cc#include "dimphy.h"
!pour klon,klev
*KEEP,YOMCST.
#include "YOMCST.h" 
*KEEP,YOETHF.
#include "YOETHF.h"
*KEEP,FCTTRE.
#include "FCTTRE.h"
!
!!##################
!   Arguments
!##################
!
!###################################
! D\'eclaration des variables
!###################################
!
        integer i,k,mlev(klon),mlon,kmb(klon),iq
!---------
!  input
!---------
        real p_e(klon,klev),mtsrf(klon,klev),t_e(klon,klev)
!---------     
! output
!---------
        real qsat_ts(klon,klev),qsat_e(klon,klev)
!---------
! local
!---------
        real zx_t,zx_qs,zcor,zdelta
!------------------------------------------------------------
c Calculer qsat par fonction thermodynaical FOEEW de FCCTRE.h 
c-------------------------------------------------------------
c
 
      DO k = 1, klev
        DO iq = 1, mlon
             i=kmb(iq)
!
!qsat_ts
             if (k.le.mlev(i)) then
            zx_t = mtsrf(i,k)
            
! 
            zdelta = MAX(0.,SIGN(1.,rtt-zx_t))
            zx_qs  = r2es * FOEEW(zx_t,zdelta)/p_e(i,k)
            zx_qs  = MIN(0.5,zx_qs)
            zcor   = 1./(1.-retv*zx_qs)
!
            qsat_ts(i,k)  = zx_qs*zcor
              endif
!
           ENDDO
        ENDDO
     
         return
         end
!***************
!   m_qsat_t   *
!***************

        SUBROUTINE m_qsat_t(mlon,kmb,mlev,p_e,m_t,qsat_t)
         USE dimphy
         implicit none
!########################
! fichiers des parametres
!########################
#include "dimensions.h"
*KEEP,dimphy.
cc#include "dimphy.h"
!pour klon,klev
*KEEP,YOMCST.
#include "YOMCST.h" 
*KEEP,YOETHF.
#include "YOETHF.h"
*KEEP,FCTTRE.
#include "FCTTRE.h"
!
!!##################
!   Arguments
!##################
!
!###################################
! D\'eclaration des variables
!###################################
!
        integer i,k,mlev(klon),mlon,kmb(klon),iq
!---------
!  input
!---------
        real p_e(klon,klev),m_t(klon,klev)
!---------     
! output
!---------
        real qsat_t(klon,klev)
!---------
! local
!---------
        real zx_t,zx_qs,zcor,zdelta
!------------------------------------------------------------
c Calculer qsat par fonction thermodynaical FOEEW de FCCTRE.h 
c-------------------------------------------------------------
c
 
      DO k = 1, klev
        DO iq = 1, mlon
            i=kmb(iq)
!
!qsat_t
            zx_t = m_t(i,k)

            zdelta = MAX(0.,SIGN(1.,rtt-zx_t))
            zx_qs  = r2es * FOEEW(zx_t,zdelta)/p_e(i,k)
            zx_qs  = MIN(0.5,zx_qs)
            zcor   = 1./(1.-retv*zx_qs)
!
            qsat_t(i,k)  = zx_qs*zcor
!
           ENDDO
        ENDDO
     
         return
         end
!***************
!   m_qsat_e   *
!***************

        SUBROUTINE m_qsat_e(mlon,kmb,mlev,p_e,t_e,qsat_e)
         USE dimphy
         implicit none
!########################
! fichiers des parametres
!########################
#include "dimensions.h"
*KEEP,dimphy.
cc#include "dimphy.h"
!pour klon,klev
*KEEP,YOMCST.
#include "YOMCST.h" 
*KEEP,YOETHF.
#include "YOETHF.h"
*KEEP,FCTTRE.
#include "FCTTRE.h"
!
!!##################
!   Arguments
!##################
!
!###################################
! D\'eclaration des variables
!###################################
!
        integer i,k,mlev(klon),mlon,kmb(klon),iq
!---------
!  input
!---------
        real p_e(klon,klev),t_e(klon,klev)
!---------     
! output
!---------
        real qsat_e(klon,klev)
!---------
! local
!---------
        real zx_t,zx_qs,zcor,zdelta
!------------------------------------------------------------
c Calculer qsat par fonction thermodynaical FOEEW de FCCTRE.h 
c-------------------------------------------------------------
c
 
      DO k = 1, klev
        DO iq = 1, mlon
            i=kmb(iq)
!
!qsat_e
            zx_t = t_e(i,k)

            zdelta = MAX(0.,SIGN(1.,rtt-zx_t))
            zx_qs  = r2es * FOEEW(zx_t,zdelta)/p_e(i,k)
            zx_qs  = MIN(0.5,zx_qs)
            zcor   = 1./(1.-retv*zx_qs)
!
            qsat_e(i,k)  = zx_qs*zcor
!
           ENDDO
        ENDDO
     
         return
         end
!***************
! m_lcl
!***************

       SUBROUTINE m_lcl(itap,rlat,rlon,mlon,kmb,
     $            p_e,t_e,tv_e,q_e,gz_e,h_e,coef_T,dzh_2,
     $            m_theta,m_t,m_tv,m_q,m_w,m_buoy,qsat_t,m_top,           
     $            rh,chi,m_icbs,m_plcl,
     $            m_q_lcl,m_theta_lcl,m_t_lcl,m_tv_lcl,
     $            m_w_lcl,gz_e_lcl,m_h_lcl,m_buoy_lcl,
     $  m_q_lcl_test,m_theta_lcl_test,m_t_lcl_test,m_tv_lcl_test,
     $  m_w_lcl_test,m_buoy_lcl_test)
         USE dimphy
         implicit none
!########################
! fichiers des parametres
!########################
#include "dimensions.h"
*KEEP,dimphy.
cc#include "dimphy.h"
!pour klon,klev
#include "YOMCST.h"
!
!##################
!   Arguments
!##################
!
!--------------
!environnement
!--------------
!
! p_e(klon,klev)  ----input-R-  pression de l'environnement au mileu
! t_e(klon,klev) ----input-R-  temperature de l'environnement (K)
! tv_e(klon,klev) ----input-R-  temperature virtuelle de l'environnement (K)
!   de la couche (Pa)
! q_e(klon,klev)  ----input-R-  l'humidit\'e sp\'ecifique de l'environnement
!      au mileu de la couche (kg/kg)?
! gz_e(klon)  ---- input-R- g\'eopotentiel 
! h_e(klon)  ---- input-R- \'energie static humide 
! t_e_lcl(klon)  ---- local-R -temp\'erature de brise au niveau LCL
! tv_e_lcl(klon)  ---- local-R-temp\'erature virtuelle de brise au niveau LCL
!
!-------------
! m_breeze
!-------------
! m_top(klon) ---- input-I- max niveau de mb
! m_icbs(klon)  ---- output-I- premier niveau endessous de LCL
! m_q(klon,klev) ---- input-R- humidit\'e sp\'ecifique de brise (kg/kg)
! qsat_t(klon,klev) ---- input-R- humidit\'e satur\'e \`a la temp\'erature
!                  de brise (kg/kg)
! m_plcl(klon)  ---- output-R- pression au niveau LCL
! m_theta_lcl(klon)  ---- output-R- temp\'erature potentiel de brise au
!                  niveau LCL
! m_t_lcl(klon)  ---- output-R- temp\'erature de brise au niveau LCL
! m_tv_lcl(klon)  ---- output-R-temp\'erature virtuelle de brise au niveau LCL
! m_q_lcl(klon)  ----  output-R- humidit\'e de brise au niveau LCL
! gz_e_lcl(klon)  ---- output-R- g\'eopotentiel au niveau LCL
! m_h_lcl(klon)  ---- output-R- \'energie static humide au niveau LCL
! m_w_lcl(klon) --- output-R- w de brise au niveau de lcl
!
!
!###################################
! D\'eclaration des variables
!###################################
!
       integer itap,i,k,mlon,kmb(klon),iq
!---------
!  input
!---------
!
!--- environnement:
      real p_e(klon,klev),q_e(klon,klev),t_e(klon,klev),tv_e(klon,klev),
     $ gz_e(klon,klev),h_e(klon,klev)
      real rlat(klon),rlon(klon)
      real theta_e(klon,klev),coef_T(klon,klev)
      real dzh_2(klon,klev)
      
!
!--- m_breeze:
      integer m_top(klon)
      real  m_theta(klon,klev),m_t(klon,klev),m_tv(klon,klev),
     $ m_q(klon,klev),m_w(klon,klev),qsat_t(klon,klev)
      real m_buoy(klon,klev)
!---------     
! output
!---------
      integer m_icbs(klon)
      real m_plcl(klon),m_q_lcl(klon),m_theta_lcl(klon),m_t_lcl(klon),
     $      m_tv_lcl(klon),m_w_lcl(klon),gz_e_lcl(klon),m_h_lcl(klon),
     $      m_buoy_lcl(klon)
!
        real m_q_lcl_test(klon), m_theta_lcl_test(klon), 
     $  m_w_lcl_test(klon), m_t_lcl_test(klon), m_tv_lcl_test(klon),
     $  m_buoy_lcl_test(klon), m_h_lcl_test(klon)
!--------
! local
!--------
 
      real A,B,rh(klon),chi(klon),frac_lcl(klon)
      real t_e_lcl(klon),tv_e_lcl(klon),q_e_lcl(klon),theta_e_lcl(klon)
      real k_PBL!coef pour regler MB vers PBL_oro
      real dzh_2_lcl,e_poten,kaka
      
        
!###########################################
! calcule le niveau de condensation de brise 
! par l'interpolation de q et qsat
!############################################
!
          do k = 2, klev
             do iq = 1,mlon
                   i= kmb(iq)
!
!au niveau de condensation, m_q =qsat_t
!
!              print*,'m_top,m_q,qsat_t',m_top(i),m_q(i,2),qsat_t(i,2)
!             if (m_q(i,k).ne.q_e(i,k)) then
!j'enl\`eve le cas o\`u pas de mb mais il y a le condensation de grande d'\'echelle
!              if (k.le.(m_top(i)+1)) then
              if (k.le.m_top(i)) then
!m_top+1:donne une chance de plus 
               if((m_q(i,k).gt.qsat_t(i,k)).and.
     $            (m_q(i,k-1).lt.qsat_t(i,k-1))) then
!
!---- m_icbs
!
               m_icbs(i) = k-1 !
!               print*,'m_icbs',m_icbs(i)
! ce test montre qu'il n'y pas de breeze arrive \`a leur niveau lcl
! 1er niveau audessous de LCL
!dans m_undilute2 le calcule de qg commence au niveau icbs+1.
!               
                endif !((m_q(i,k).gt.qsat_t(i,k)).and.
!     $            (m_q(i,k-1).lt.qsat_t(i,k-1))) 
              endif!(k.le.(m_top(i)+1)) 
             enddo
           enddo        
      
!-----------------------------------------------------
!  formule adiabatique pour m_plcl
!------------------------------------------------------
  
         do iq=1,mlon
              i= kmb(iq)

        A = 1669.0 ! convect3
        B = 122.0  ! convect3
             if (m_icbs(i).gt.0) then
        rh(i)=m_q(i,m_icbs(i))/qsat_t(i,m_icbs(i))
        chi(i)=m_t(i,m_icbs(i))/(A-B*rh(i)-m_t(i,m_icbs(i))) ! convect3
!        IF(rh(i) .LT. 0) print *,' =====>> rh<0, itap, i ', itap,i
        m_plcl(i)=p_e(i,m_icbs(i))*(rh(i)**chi(i)) 
!----------------------------
!--- test pour m_plcl
       
!        print*,'itap,m_icbs,rlon,rlat,m_plcl',
!     $        itap,m_icbs(i),rlon(i),rlat(i),m_plcl(i)
!qu'une seule point dans la journe avec m_icbs>0       
!
!---------------------------------------------
!-- test pour m_plcl
!        print*,'m_icbs>0,rh,chi,m_plcl',
!     $   m_icbs(i),rh(i),chi(i),m_plcl(i)
!           if (rh(i).lt.0) then
!            print*,'m_icbs>0,rh<0,rh,m_q,qsat_t',
!     $       rh(i),m_q(i,k),qsat_t(i,k)
!           endif
!-------------------------------------------------
            elseif (m_top(i).gt.0) then

        rh(i)=m_q(i,m_top(i))/qsat_t(i,m_top(i))
        chi(i)=m_t(i,m_top(i))/(A-B*rh(i)-m_t(i,m_top(i))) ! convect3
!        IF(rh(i) .LT. 0) print *,' =====>> rh<0, itap, i ', itap,i
        m_plcl(i)=p_e(i,m_top(i))*(rh(i)**chi(i)) 
!
!---------------------------------------------
!-- test pour m_plcl
!         print*,'m_icbs=0,m_top>0,rh,chi,m_plcl',
!     $   m_icbs(i),rh(i),chi(i),m_plcl(i)
!           if (rh(i).lt.0) then
!            print*,'m_top>0,rh<0,rh,m_q,qsat_t',
!     $       rh(i),m_q(i,k),qsat_t(i,k)
!           endif
!          if (m_plcl(i).le.0.) then
!             print*,'m_top>0,m_plcl=0',m_top(i),m_plcl(i)
!          endif
!ce cas n'existe pas
!--------------------------------------------------------
!Oublie pas qu'il a la chance que m_plcl se trouve un peu
!plus haute de m_top
             endif !(m_icbs(i).gt.0) 
              if (m_plcl(i).lt.p_e(i,m_top(i)+1)) then
                   m_plcl(i)=0.
             endif
         enddo
!
!-------------------------------------------------------------
! Calculer les quantit\'es \`a LCL par frac_lcl
!-------------------------------------------------------------
!-init
       
         do i=1,klon
             m_h_lcl(i)=0.
             m_h_lcl_test(i)=0.
         enddo

         do k=1,klev
           do iq=1,mlon
             i= kmb(iq)
             theta_e(i,k)=t_e(i,k)/coef_T(i,k)
           enddo
         enddo
!---  k_PBL=(quant-quant_prim)/(quant-quant_env)
!     quant_prim=quant-k_PBL*(quant-quant_env)
!quant:quantit\'e,quant_prim:quantit\'e estim\'e come thermal PBL,
!quant_env:quantit\'e de l'environement
!         k_PBL=0.1
          k_PBL=0.
!aparament m_trigger n'est pas tr\`es sensible \`a k_PBL soit 0.1,soit 0.95
!         RCPD=3.5*287.04

!------------------------
        do k=1,klev-1
         do iq=1,mlon
             i= kmb(iq)
        if ((m_plcl(i).gt.p_e(i,k+1)).and.(m_plcl(i).lt.p_e(i,k))) then
!
!----  recalcule m_icbs par m_plcl
!
                 m_icbs(i)= k
!
!---- frac_lcl
!      print *,'i, k, p_e(i,k), m_plcl(i), p_e(i,k+1) ',
!     $         i, k, p_e(i,k), m_plcl(i), p_e(i,k+1)
          frac_lcl(i)=
     $   (p_e(i,k)-m_plcl(i))/(p_e(i,k)-p_e(i,k+1))
!A_lcl=frac_lcl*(A(k+1)-A(k))+A(k)
!        print*,'frac_lcl,frac_lcl',frac_lcl,frac_lcl
!---- m_q_lcl

        m_q_lcl(i)=frac_lcl(i)*(m_q(i,k+1)-m_q(i,k))+m_q(i,k)    
!        print*,'2 m_q_lcl ',m_q_lcl(i) 
!
!---- m_theta_lcl,m_t_lcl,m_tv_lcl
         m_theta_lcl(i) =frac_lcl(i)*(m_theta(i,k+1)-m_theta(i,k))+
     $                   m_theta(i,k) 
!        print*,'m_theta_lcl avant',m_theta_lcl(i) 
!
         m_t_lcl(i) =frac_lcl(i)*(m_t(i,k+1)-m_t(i,k))+ m_t(i,k) 
!        print*,'m_t_lcl avant',m_t<_lcl(i)
       
         m_tv_lcl(i) =frac_lcl(i)*(m_tv(i,k+1)-m_tv(i,k))+ m_tv(i,k) 
!        print*,'m_tv_lcl avant',m_tv_lcl(i)

!---- q_e_lcl
         q_e_lcl(i) = frac_lcl(i)*(q_e(i,k+1)-q_e(i,k))+ q_e(i,k) 
!---- t_e_lcl,tv_e_lcl,theta_e_lcl
         t_e_lcl(i) =frac_lcl(i)*(t_e(i,k+1)-t_e(i,k))+ t_e(i,k) 
         tv_e_lcl(i) =frac_lcl(i)*(tv_e(i,k+1)-tv_e(i,k))+ tv_e(i,k) 
         theta_e_lcl(i)=frac_lcl(i)*(theta_e(i,k+1)-theta_e(i,k))+ 
     $                  theta_e(i,k) 
!---- gz_e_lcl,m_h_lcl
         gz_e_lcl(i)=frac_lcl(i)*(gz_e(i,k+1)-gz_e(i,k))+ 
     $                  gz_e(i,k) 
!         m_h_lcl(i)=frac_lcl(i)*(m_h(i,k+1)-m_h(i,k))+ 
!     $                  m_h(i,k) 
!        print*,'m_h_lcl avant,avec RCPD',m_h_lcl(i)
!c'est mieux par rapport avec frac.
!
!---- m_buoy_lcl
        m_buoy_lcl(i)=m_tv_lcl(i)-tv_e_lcl(i)
!        print*,'m_buoy_lcl avant',m_buoy_lcl(i)
! m_plcl entre m_icbs et m_icb
           dzh_2_lcl = dzh_2(i,k+1)*frac_lcl(i)
           e_poten= RG*(m_buoy(i,k)+m_buoy_lcl(i))
     $          /(tv_e(i,k)+tv_e_lcl(i))*dzh_2_lcl       
           kaka=e_poten+0.5*m_w(i,k)**2
                if (kaka.gt.0) then
                  m_w_lcl(i)=sqrt(2.*kaka)
                endif
!
        if (m_w_lcl(i).eq.0.)then
            m_theta_lcl(i)=0.
            m_q_lcl(i)=0.
            m_t_lcl(i)=0.
            m_tv_lcl(i)=0.
            m_h_lcl(i)=0.
            m_buoy_lcl(i)=0.
            m_plcl(i)=0.
            m_icbs(i)=0
       endif!(m_w_lcl(i).eq.0.)
!-----------------------------------------------------
!
!---  correction par k_PBL
!m_t_lcl=m_theta_lcl*coef ne marche pas
!il faut prends t_e_lcl,pas t_e(m_icbs)

!
        m_q_lcl_test(i)=m_q_lcl(i)-k_PBL*abs((m_q_lcl(i)-q_e_lcl(i)))
!        print*,'m_q_lcl apr\`as',m_q_lcl_test(i)
!        if(m_q_lcl(i).lt.m_q_lcl_test(i)) then
!        print*,'m_q_lcl<m_q_lcl_test,m_q_lcl,q_e_lcl',
!     $  m_q_lcl(i),q_e_lcl(i)
!        endif
!ca prouve qu'il existe q_e_lcl>m_q_lcl et t_e_lcl>m_t_lcl quand buoy_lcl<0
!j'ajoute abs pour etre sure que m_q_lcl_test<m_q_lcl

        m_theta_lcl_test(i) =m_theta_lcl(i)-
     $           k_PBL*abs(m_theta_lcl(i)-theta_e_lcl(i))
!        print*,'m_theta_lcl_test',m_theta_lcl_test(i)
!        if(m_theta_lcl(i).lt.m_theta_lcl_test(i)) then
!        print*,'m_theta_lcl<m_theta_lcl_test,m_theta_lcl,theta_e_lcl',
!     $  m_theta_lcl(i),theta_e_lcl(i)
!        endif

        m_w_lcl_test(i) =m_w_lcl(i)- k_PBL*m_w_lcl(i)
      
        m_t_lcl_test(i) =m_t_lcl(i)-
     $  k_PBL*abs(m_t_lcl(i)-t_e_lcl(i))
!        print*,'m_t_lcl,k_PBL,t_e_lcl,m_t_lcl_test',
!     $   m_t_lcl(i),k_PBL,t_e_lcl(i),m_t_lcl_test(i)
!        if(m_t_lcl(i).lt.m_t_lcl_test(i)) then
!        print*,'m_t_lcl<m_t_lcl_test,m_t_lcl,t_e_lcl',
!     $  m_t_lcl(i),t_e_lcl(i)
!        endif

        m_tv_lcl_test(i) =m_tv_lcl(i)-
     $              k_PBL*abs(m_tv_lcl(i)-tv_e_lcl(i))
!        print*,'m_tv_lcl_test',m_tv_lcl_test(i)
!        if(m_tv_lcl(i).lt.m_tv_lcl_test(i)) then
!!        print*,'m_tv_lcl<m_tv_lcl_test,m_tv_lcl,tv_e_lcl',
!     $  m_tv_lcl(i),tv_e_lcl(i)
!        endif

        m_buoy_lcl_test(i) =m_tv_lcl_test(i)-tv_e_lcl(i)
!        print*,'m_buoy_lcl_test',m_buoy_lcl_test(i)
!        if(m_buoy_lcl(i).lt.m_buoy_lcl_test(i)) then
!        print*,'m_buoy_lcl<m_buoy_lcl_test,m_buoy_lcl,m_buoy_lcl_test',
!     $  m_buoy_lcl(i),m_buoy_lcl_test(i)
!        endif

        m_h_lcl_test(i) = gz_e_lcl(i)+RCPD*m_t_lcl_test(i) 
!        print*,'m_h_lcl_test',m_h_lcl_test(i)
!        if(m_h_lcl(i).lt.m_h_lcl_test(i)) then
!        print*,'m_h_lcl<m_h_lcl_test,m_h_lcl,m_h_lcl_test',
!     $  m_h_lcl(i),m_h_lcl_test(i)
!        endif

          endif !((m_plcl(i).gt.p_e(i,k+1).and.(m_plcl(i).lt.p_e(i,k))) 
!---------------------------------------------
!-- test pour m_plcl        
!        print*,'new m_icbs,rh,chi,m_plcl',
!     $   m_icbs(i),rh(i),chi(i),m_plcl(i)
!
!         if (m_icbs(i).eq.1) then
!          print*,'m_icbs=1,k,m_q,qsat_t,rlat,rlon',
!     $       k,m_q(i,k),qsat_t(i,k),rlat(i),rlon(i)
!seule rlat=45,rlon=-56.25,qsat_t>m_q dans toutes les couches
!            if (m_plcl(i).lt.30000.) then
!              print*,'m_icbs=1,m_plcl<300hpa,m_plcl',m_plcl(i)
!cette cas n'existe pas
!            endif
!         endif
!-------------------------------------------------
         enddo
        enddo
!***********************************************   
       return
       end

!***************
! m_tsurf
!***************
!
      SUBROUTINE m_tsurf(mlon,kmb,itap,mlev,slope,dzh,msig,
     $  cdragh,m_beta,
     $  qsat_ts,A_sol,B_sol,
     $  theta_e,coef_T,q_e,rho_e,lwdn,mflux_swdn,
     $  m_wf_breeze,m_theta_breeze,m_q_breeze,
     $  mfluxg1,mflux_sens,mflux_lat,mflux_lw,mtsrf,
     $  dwfdTs,dTdTs,dqdTs)
   
         USE dimphy
         implicit none

!########################
! fichiers des parametres
!########################
#include "dimensions.h"
*KEEP,dimphy.
cc#include "dimphy.h"
!pour klon,klev
*KEEP,YOMCST.
#include "YOMCST.h" 
*KEEP,YOETHF.
#include "YOETHF.h"
*KEEP,FCTTRE.
#include "FCTTRE.h"
#include "cvthermo.h"
#include "cv3param.h"
#include "conema3.h"
#include "iniprint.h"
*KEND.
!
!
!##################
!   Arguments
!##################
!
!###################################
! D\'eclaration des variables
!###################################
!
       integer i,k,mlev(klon),itap,mlon,kmb(klon),iq
!---------
!  input
!---------
!--- caract\'eristiques de surface de relief
      real slope(klon),dzh(klon,klev),msig(klev)
      real cdragh(klon),m_beta(klon)
      real qsat_ts(klon,klev), A_sol(klon,klev),B_sol(klon,klev)
      real dwfdTs(klon,klev),dTdTs(klon,klev),dqdTs(klon,klev)

!--- environenment
       real theta_e(klon,klev),coef_T(klon,klev),q_e(klon,klev),
     $      rho_e(klon,klev),lwdn(klon,klev),mflux_swdn(klon,klev)
  
!--- m_breeze
       real m_wf_breeze(klon,klev+1),m_theta_breeze(klon,klev),
     $      m_q_breeze(klon,klev)
!---------     
! output
!---------
       real mfluxg1(klon,klev),mflux_sens(klon,klev),
     $      mflux_lat(klon,klev),mflux_lw(klon,klev),mtsrf(klon,klev)
!--------
! local
!--------
       real spring
       real ky1,ky2,ky3,ky5,p_sens(klon,klev),q_buoy(klon,klev),
     $      coef_sens_mt,dmflux_sensdTs,A_sens,B_sens,
     $      coef_lat_mt,dmflux_latdTs,dqsatdT,A_lat,B_lat,A_lw,B_lw
       real test_bilan(klon,klev)
       logical firstcall,decoupling
! variables de brise vues par le modele de sol
       real m_wf(klon,klev+1),m_theta(klon,klev),m_q(klon,klev)
c
      data firstcall /.TRUE./, decoupling /.FALSE./
C
c
c -----------------------------------------------------------------
c             Initialisation des paramtres
c -----------------------------------------------------------------
      IF (firstcall) THEN
        firstcall = .FALSE.
c
        decoupling = .FALSE.
c
c--  Lecture ventuelle des parametres dans m_tsurf_param.data
c
        open(99,file='m_tsurf_param.data',status='old',
     $          form='formatted',err=9999)
        read(99,*,end=9998) decoupling
9998    Continue
        close(99)
        print *,
     $  ' lecture m_tsurf_param.data: decoupling',
     $              decoupling
9999    Continue
      ENDIF   ! Firstcall
!-------------------------------------------------------------------
      IF (decoupling) THEN
!--- test de decouplage avec m_breeze
       do k=1,klev
         do iq=1,mlon
             i= kmb(iq)
               m_theta(i,k)=theta_e(i,k)
               m_q(i,k)=q_e(i,k)
               m_wf(i,k)=1.
           enddo
       enddo
      ELSE
       do k=1,klev
         do iq=1,mlon
             i= kmb(iq)
               m_theta(i,k)=m_theta_breeze(i,k)
               m_q(i,k)=m_q_breeze(i,k)
               m_wf(i,k)=m_wf_breeze(i,k)
           enddo
       enddo
      ENDIF
!--- end test
!**********************
!mflux=A+B*mtsrf
!   A=mflux-B*mtsrf
!   B=d(mflux)/d(mtsrf)
!convention de signe :                                       !jylmd
!   1)B>0,soit quand on augemente mtsrf, mflux augement.     !jylmd
!   2)a midi, bien ensoleille: tous les flux sont positives. !jylmd
!convention de signe (vision jyg)
!  tous les flux sortant de la surface sont comptes positivement
! en s'eloignant de la surface.
!bilan : 
!   sum(flux_entrant)=sum(flux_sortant)
!       flux_entrant: swdn,lwdn
!       flux_sortant: sens,lat,lwup,g1
!mtsrf=(mflux_swdn-lwdn-sumA)/sumB
!   lwdn est toujour negative
!**********************
c -----------------------------------------------------------------
!
!##################################################
! recalcule mtsrf par bilan d'\'energy \`a la surface #
!##################################################
!         print*,' itap= ',itap,' recalcul de mtsrf par bilan 
!     $ d energy a la surface'
!          do iq=1,mlon
!              i= kmb(iq)
!             print*,'itap,mtsrf,head of m_tsurf',itap,mtsrf(i,1)
!          enddo
!-----------------------------------------

       do k=1,klev
         do iq=1,mlon
             i= kmb(iq)
              if (k.le.mlev(i)) then
!------------------
! A_sens,B_sens(1)
!------------------
!        ky1 =  RG/theta_e(i,k)*dzh(i,k)/coef_T(i,k)
!!
!      if (k.eq.1) then
!        ky2 = cdragh(i)*2.*dzh(i,k)*msig(k)
!        ky3 = 0.
!      else
!        spring=abs(m_wf(i,k))*sin(slope(i))+1.
!        ky2 = cdragh(i)*spring*
!     $        dzh(i,k)*msig(k)
!        ky3 = abs(m_wf(i,k))*(m_theta(i,k-1)-theta_e(i,k))
!      endif
!!
!        p_sens(i,k) =  mtsrf(i,k)-theta_e(i,k)*coef_T(i,k)-m_buoy(i,k)
        p_sens(i,k) =  mtsrf(i,k)-m_theta(i,k)*coef_T(i,k)
!
        q_buoy(i,k) =  (m_theta(i,k)-theta_e(i,k))*coef_T(i,k)
     
!changement de m_buoy \`a q_buoy, car m_buoy a chang\'e par le boucle de ip
!
!        ky5 = ky2*coef_T(i,k)*p_sens(i,k)+ky3*coef_T(i,k)
!!
!        dTdTs(i,k) = -2.*ky5*ky2*coef_T(i,k)/
!     $     (3.*q_buoy(i,k)**2*ky1+ 2.*q_buoy(i,k)*m_wf(i,k)**2+
!     $      2.*ky5*ky2*coef_T(i,k))
!        print*,'dTdTs',dTdTs(i,k),'dqdTs',dqdTs(i,k),
!     $      'dwfdTs',dwfdTs(i,k)
!
!!!        spring=abs(m_wf(i,k))*sin(slope(i))+1.
        spring=abs(m_wf(i,k))/sin(slope(i))+1.
!
        coef_sens_mt = rho_e(i,k)*RCPD*cdragh(i)*spring
!
        mflux_sens(i,k) = coef_sens_mt*p_sens(i,k)

        dmflux_sensdTs = coef_sens_mt*(1.-dTdTs(i,k))
!
        B_sens = dmflux_sensdTs
        A_sens =  mflux_sens(i,k)- B_sens*mtsrf(i,k)
 
!---------------------
! A_lat,B_lat(1)
!----------------------
                  
         coef_lat_mt = RLVTT*m_beta(i)*rho_e(i,k)*cdragh(i)*spring
!
         dqsatdT = qsat_ts(i,k)*RLVTT/(RV*mtsrf(i,k)**2)
! Clausius-Clapeyron
!
         mflux_lat(i,k) = coef_lat_mt*(qsat_ts(i,k)-m_q(i,k))
         dmflux_latdTs =  coef_lat_mt* (dqsatdT-dqdTs(i,k))
         B_lat = dmflux_latdTs
         A_lat = mflux_lat(i,k)-B_lat*mtsrf(i,k)
!
!---------------------
! A_lw,B_lw(1)
!----------------------
!
         mflux_lw(i,k)=RSIGMA*mtsrf(i,k)**4
         B_lw= 4.*RSIGMA*mtsrf(i,k)**3
         A_lw = mflux_lw(i,k)-B_lw*mtsrf(i,k)
!
!---------------------
! Sol
!----------------------
!
         mfluxg1(i,k) = A_sol(i,k)+B_sol(i,k)*mtsrf(i,k)
!
!----------------------
! test_bilan
!----------------------
         test_bilan(i,k) = mflux_swdn(i,k) -lwdn(i,k)-
     $  (mflux_sens(i,k) + mflux_lat(i,k)+ mflux_lw(i,k) + mfluxg1(i,k))
!       print *,'test bilan, avant, mtsrf ',test_bilan(i,k),mtsrf(i,k)
!---------------------
! New mtsrf
!--------------------------------------------------------------------      
              mtsrf(i,k) =(mflux_swdn(i,k) -lwdn(i,k) - 
     $         (A_sens + A_lat + A_lw + A_sol(i,k)))/
     $         (B_sens + B_lat + B_lw + B_sol(i,k))
!
!            print*,'mtsrf',mtsrf(i,k)
!---------------------------------------------------------------------
                mfluxg1(i,k) = A_sol(i,k)+B_sol(i,k)*mtsrf(i,k)
                mflux_sens(i,k) = A_sens+B_sens*mtsrf(i,k)
                mflux_lat(i,k) = A_lat+B_lat*mtsrf(i,k)
                mflux_lw(i,k) = A_lw+B_lw*mtsrf(i,k)
!                print*,'mfluxg1',mfluxg1(i,k)
!                print*,'mflux_sens',mflux_sens(i,k)
!                mflux_lw(i,k)=-RSIGMA*mtsrf(i,k)**4
!pour eviter le pic au lever de soleille, utilise que quand pour sortie 
!flux2
!
         test_bilan(i,k) = mflux_swdn(i,k) -lwdn(i,k)-
     $  (mflux_sens(i,k) + mflux_lat(i,k)+ mflux_lw(i,k) + mfluxg1(i,k))
               if (prt_level .ge.30) then
       print *,'test bilan, apres, mtsrf ',test_bilan(i,k),mtsrf(i,k)
       print *,'A_sol,B_sol ',A_sol(i,k),B_sol(i,k)
       print *,'A_lw,B_lw ',A_lw,B_lw
       print *,'A_sens,B_sens ',A_sens,B_sens
       print *,'A_lat,B_lat,m_beta(i) ',A_lat,B_lat,m_beta(i)
               endif !(prt_level .ge.30)
             endif !(k.le.mlev(i)) 
            enddo
           enddo
!---------------------------------
! --- test p_sens,q_buoy
!         do iq=1,mlon
!              i=kmb(iq)
!         print*,'itap,p_sens,q_buoy',
!     $         itap,p_sens(100,1),q_buoy(100,1)
!          print*,'itap,mtsrf,m_t',
!     $      itap,mtsrf(i,1),m_theta(i,1)*coef_T(i,1)
!         enddo
!          print*,'mfluxg1,mflux_sens,mflux_lat,mflux_lw,test_bilan',
!     $mfluxg1(1,1),mflux_sens(1,1),mflux_lat(1,1),
!     $mflux_lw(1,1),test_bilan(1,1)
!dans la journe, mflux_sens,mflux_lat>0,mfluxg1,mflux_lw<0.
!-----------------------------------------------------------
!limiter mflux_swdn au-dessus de mlev
         do k=1,klev
          do iq=1,mlon
           i=kmb(iq)
           if (k.gt.mlev(i)) then
!control mflux_swdn comme les autres mflux dans m_breeze  
             mflux_swdn(i,k) = 0.
           endif! (k.gt.mlev(i))
          enddo
         enddo
!------------------------------------------
!***********************************************   
       return
       end      
